import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDashboardControlViewerApiComponent extends NestedOption implements OnDestroy, OnInit {
    get onDashboardTitleToolbarUpdated(): Function;
    set onDashboardTitleToolbarUpdated(value: Function);
    get onItemActionAvailabilityChanged(): Function;
    set onItemActionAvailabilityChanged(value: Function);
    get onItemCaptionToolbarUpdated(): Function;
    set onItemCaptionToolbarUpdated(value: Function);
    get onItemClick(): Function;
    set onItemClick(value: Function);
    get onItemDrillDownStateChanged(): Function;
    set onItemDrillDownStateChanged(value: Function);
    get onItemElementCustomColor(): Function;
    set onItemElementCustomColor(value: Function);
    get onItemMasterFilterStateChanged(): Function;
    set onItemMasterFilterStateChanged(value: Function);
    get onItemSelectionChanged(): Function;
    set onItemSelectionChanged(value: Function);
    get onItemVisualInteractivity(): Function;
    set onItemVisualInteractivity(value: Function);
    get onItemWidgetCreated(): Function;
    set onItemWidgetCreated(value: Function);
    get onItemWidgetOptionsPrepared(): Function;
    set onItemWidgetOptionsPrepared(value: Function);
    get onItemWidgetUpdated(): Function;
    set onItemWidgetUpdated(value: Function);
    get onItemWidgetUpdating(): Function;
    set onItemWidgetUpdating(value: Function);
    get onSelectedTabPageChanged(): Function;
    set onSelectedTabPageChanged(value: Function);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDashboardControlViewerApiComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDashboardControlViewerApiComponent, "dxo-dashboard-control-viewer-api", never, { "onDashboardTitleToolbarUpdated": { "alias": "onDashboardTitleToolbarUpdated"; "required": false; }; "onItemActionAvailabilityChanged": { "alias": "onItemActionAvailabilityChanged"; "required": false; }; "onItemCaptionToolbarUpdated": { "alias": "onItemCaptionToolbarUpdated"; "required": false; }; "onItemClick": { "alias": "onItemClick"; "required": false; }; "onItemDrillDownStateChanged": { "alias": "onItemDrillDownStateChanged"; "required": false; }; "onItemElementCustomColor": { "alias": "onItemElementCustomColor"; "required": false; }; "onItemMasterFilterStateChanged": { "alias": "onItemMasterFilterStateChanged"; "required": false; }; "onItemSelectionChanged": { "alias": "onItemSelectionChanged"; "required": false; }; "onItemVisualInteractivity": { "alias": "onItemVisualInteractivity"; "required": false; }; "onItemWidgetCreated": { "alias": "onItemWidgetCreated"; "required": false; }; "onItemWidgetOptionsPrepared": { "alias": "onItemWidgetOptionsPrepared"; "required": false; }; "onItemWidgetUpdated": { "alias": "onItemWidgetUpdated"; "required": false; }; "onItemWidgetUpdating": { "alias": "onItemWidgetUpdating"; "required": false; }; "onSelectedTabPageChanged": { "alias": "onSelectedTabPageChanged"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDashboardControlViewerApiModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDashboardControlViewerApiModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDashboardControlViewerApiModule, [typeof DxoDashboardControlViewerApiComponent], never, [typeof DxoDashboardControlViewerApiComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDashboardControlViewerApiModule>;
}
