import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDashboardControlWizardSettingsComponent extends NestedOption implements OnDestroy, OnInit {
    get enableFederationDataSource(): boolean;
    set enableFederationDataSource(value: boolean);
    get enableJsonDataSource(): boolean;
    set enableJsonDataSource(value: boolean);
    get enableOlapDataSource(): boolean;
    set enableOlapDataSource(value: boolean);
    get enableSqlDataSource(): boolean;
    set enableSqlDataSource(value: boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDashboardControlWizardSettingsComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDashboardControlWizardSettingsComponent, "dxo-dashboard-control-wizard-settings", never, { "enableFederationDataSource": { "alias": "enableFederationDataSource"; "required": false; }; "enableJsonDataSource": { "alias": "enableJsonDataSource"; "required": false; }; "enableOlapDataSource": { "alias": "enableOlapDataSource"; "required": false; }; "enableSqlDataSource": { "alias": "enableSqlDataSource"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDashboardControlWizardSettingsModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDashboardControlWizardSettingsModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDashboardControlWizardSettingsModule, [typeof DxoDashboardControlWizardSettingsComponent], never, [typeof DxoDashboardControlWizardSettingsComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDashboardControlWizardSettingsModule>;
}
