import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDashboardExportComponent extends NestedOption implements OnDestroy, OnInit {
    get allowExportDashboard(): boolean;
    set allowExportDashboard(value: boolean);
    get allowExportDashboardItems(): boolean;
    set allowExportDashboardItems(value: boolean);
    get onExportDialogHidden(): Function;
    set onExportDialogHidden(value: Function);
    get onExportDialogShowing(): Function;
    set onExportDialogShowing(value: Function);
    get onExportDialogShown(): Function;
    set onExportDialogShown(value: Function);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDashboardExportComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDashboardExportComponent, "dxo-dashboard-export", never, { "allowExportDashboard": { "alias": "allowExportDashboard"; "required": false; }; "allowExportDashboardItems": { "alias": "allowExportDashboardItems"; "required": false; }; "onExportDialogHidden": { "alias": "onExportDialogHidden"; "required": false; }; "onExportDialogShowing": { "alias": "onExportDialogShowing"; "required": false; }; "onExportDialogShown": { "alias": "onExportDialogShown"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDashboardExportModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDashboardExportModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDashboardExportModule, [typeof DxoDashboardExportComponent], never, [typeof DxoDashboardExportComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDashboardExportModule>;
}
