import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataInspectorComponent extends NestedOption implements OnDestroy, OnInit {
    get allowInspectAggregatedData(): boolean;
    set allowInspectAggregatedData(value: boolean);
    get allowInspectRawData(): boolean;
    set allowInspectRawData(value: boolean);
    get onDialogHidden(): Function;
    set onDialogHidden(value: Function);
    get onDialogShowing(): Function;
    set onDialogShowing(value: Function);
    get onDialogShown(): Function;
    set onDialogShown(value: Function);
    get onGridContentReady(): Function;
    set onGridContentReady(value: Function);
    get onGridInitialized(): Function;
    set onGridInitialized(value: Function);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataInspectorComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataInspectorComponent, "dxo-data-inspector", never, { "allowInspectAggregatedData": { "alias": "allowInspectAggregatedData"; "required": false; }; "allowInspectRawData": { "alias": "allowInspectRawData"; "required": false; }; "onDialogHidden": { "alias": "onDialogHidden"; "required": false; }; "onDialogShowing": { "alias": "onDialogShowing"; "required": false; }; "onDialogShown": { "alias": "onDialogShown"; "required": false; }; "onGridContentReady": { "alias": "onGridContentReady"; "required": false; }; "onGridInitialized": { "alias": "onGridInitialized"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDataInspectorModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataInspectorModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataInspectorModule, [typeof DxoDataInspectorComponent], never, [typeof DxoDataInspectorComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataInspectorModule>;
}
