import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataRequestOptionsComponent extends NestedOption implements OnDestroy, OnInit {
    get itemDataLoadingMode(): string;
    set itemDataLoadingMode(value: string);
    get itemDataRequestMode(): string;
    set itemDataRequestMode(value: string);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataRequestOptionsComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataRequestOptionsComponent, "dxo-data-request-options", never, { "itemDataLoadingMode": { "alias": "itemDataLoadingMode"; "required": false; }; "itemDataRequestMode": { "alias": "itemDataRequestMode"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDataRequestOptionsModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataRequestOptionsModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataRequestOptionsModule, [typeof DxoDataRequestOptionsComponent], never, [typeof DxoDataRequestOptionsComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataRequestOptionsModule>;
}
