import { OnInit, OnDestroy } from '@angular/core';
import { IDashboardDataSourceWizardSettings } from 'devexpress-dashboard/designer/data-source-wizard/data-source-wizard-extension';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataSourceWizardComponent extends NestedOption implements OnDestroy, OnInit {
    get allowCreateNewJsonConnection(): boolean;
    set allowCreateNewJsonConnection(value: boolean);
    get enableCustomSql(): boolean;
    set enableCustomSql(value: boolean);
    get onCustomizeDataSourceWizard(): Function;
    set onCustomizeDataSourceWizard(value: Function);
    get wizardSettings(): IDashboardDataSourceWizardSettings;
    set wizardSettings(value: IDashboardDataSourceWizardSettings);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataSourceWizardComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataSourceWizardComponent, "dxo-data-source-wizard", never, { "allowCreateNewJsonConnection": { "alias": "allowCreateNewJsonConnection"; "required": false; }; "enableCustomSql": { "alias": "enableCustomSql"; "required": false; }; "onCustomizeDataSourceWizard": { "alias": "onCustomizeDataSourceWizard"; "required": false; }; "wizardSettings": { "alias": "wizardSettings"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDataSourceWizardModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataSourceWizardModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataSourceWizardModule, [typeof DxoDataSourceWizardComponent], never, [typeof DxoDataSourceWizardComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataSourceWizardModule>;
}
