import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoMobileLayoutComponent extends NestedOption implements OnDestroy, OnInit {
    get mobileLayoutEnabled(): string;
    set mobileLayoutEnabled(value: string);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoMobileLayoutComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoMobileLayoutComponent, "dxo-mobile-layout", never, { "mobileLayoutEnabled": { "alias": "mobileLayoutEnabled"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoMobileLayoutModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoMobileLayoutModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoMobileLayoutModule, [typeof DxoMobileLayoutComponent], never, [typeof DxoMobileLayoutComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoMobileLayoutModule>;
}
