import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoIDashboardDataSourceWizardSettings } from './base/i-dashboard-data-source-wizard-settings';
import * as i0 from "@angular/core";
export declare class DxoWizardSettingsComponent extends DxoIDashboardDataSourceWizardSettings implements OnDestroy, OnInit {
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoWizardSettingsComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoWizardSettingsComponent, "dxo-wizard-settings", never, { "enableFederationDataSource": { "alias": "enableFederationDataSource"; "required": false; }; "enableJsonDataSource": { "alias": "enableJsonDataSource"; "required": false; }; "enableOlapDataSource": { "alias": "enableOlapDataSource"; "required": false; }; "enableSqlDataSource": { "alias": "enableSqlDataSource"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoWizardSettingsModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoWizardSettingsModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoWizardSettingsModule, [typeof DxoWizardSettingsComponent], never, [typeof DxoWizardSettingsComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoWizardSettingsModule>;
}
