import * as i0 from '@angular/core';
import { Input, SkipSelf, Host, Component, NgModule } from '@angular/core';
import * as i1 from 'devextreme-angular/core';
import { NestedOption, NestedOptionHost } from 'devextreme-angular/core';

/* tslint:disable:max-line-length */
class DxoDashboardControlAjaxRemoteServiceComponent extends NestedOption {
    get beforeSend() {
        return this._getOption('beforeSend');
    }
    set beforeSend(value) {
        this._setOption('beforeSend', value);
    }
    get complete() {
        return this._getOption('complete');
    }
    set complete(value) {
        this._setOption('complete', value);
    }
    get headers() {
        return this._getOption('headers');
    }
    set headers(value) {
        this._setOption('headers', value);
    }
    get _optionPath() {
        return 'ajaxRemoteService';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlAjaxRemoteServiceComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlAjaxRemoteServiceComponent, selector: "dxo-dashboard-control-ajax-remote-service", inputs: { beforeSend: "beforeSend", complete: "complete", headers: "headers" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlAjaxRemoteServiceComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-ajax-remote-service', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { beforeSend: [{
                type: Input
            }], complete: [{
                type: Input
            }], headers: [{
                type: Input
            }] } });
class DxoDashboardControlAjaxRemoteServiceModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlAjaxRemoteServiceModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlAjaxRemoteServiceModule, declarations: [DxoDashboardControlAjaxRemoteServiceComponent], exports: [DxoDashboardControlAjaxRemoteServiceComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlAjaxRemoteServiceModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlAjaxRemoteServiceModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlAjaxRemoteServiceComponent
                    ],
                    exports: [
                        DxoDashboardControlAjaxRemoteServiceComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlChartIndicatorsComponent extends NestedOption {
    get customIndicatorTypes() {
        return this._getOption('customIndicatorTypes');
    }
    set customIndicatorTypes(value) {
        this._setOption('customIndicatorTypes', value);
    }
    get _optionPath() {
        return 'chartIndicators';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlChartIndicatorsComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlChartIndicatorsComponent, selector: "dxo-dashboard-control-chart-indicators", inputs: { customIndicatorTypes: "customIndicatorTypes" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlChartIndicatorsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-chart-indicators', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { customIndicatorTypes: [{
                type: Input
            }] } });
class DxoDashboardControlChartIndicatorsModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlChartIndicatorsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlChartIndicatorsModule, declarations: [DxoDashboardControlChartIndicatorsComponent], exports: [DxoDashboardControlChartIndicatorsComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlChartIndicatorsModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlChartIndicatorsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlChartIndicatorsComponent
                    ],
                    exports: [
                        DxoDashboardControlChartIndicatorsComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlDashboardExportComponent extends NestedOption {
    get allowExportDashboard() {
        return this._getOption('allowExportDashboard');
    }
    set allowExportDashboard(value) {
        this._setOption('allowExportDashboard', value);
    }
    get allowExportDashboardItems() {
        return this._getOption('allowExportDashboardItems');
    }
    set allowExportDashboardItems(value) {
        this._setOption('allowExportDashboardItems', value);
    }
    get onExportDialogHidden() {
        return this._getOption('onExportDialogHidden');
    }
    set onExportDialogHidden(value) {
        this._setOption('onExportDialogHidden', value);
    }
    get onExportDialogShowing() {
        return this._getOption('onExportDialogShowing');
    }
    set onExportDialogShowing(value) {
        this._setOption('onExportDialogShowing', value);
    }
    get onExportDialogShown() {
        return this._getOption('onExportDialogShown');
    }
    set onExportDialogShown(value) {
        this._setOption('onExportDialogShown', value);
    }
    get _optionPath() {
        return 'dashboardExport';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardExportComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlDashboardExportComponent, selector: "dxo-dashboard-control-dashboard-export", inputs: { allowExportDashboard: "allowExportDashboard", allowExportDashboardItems: "allowExportDashboardItems", onExportDialogHidden: "onExportDialogHidden", onExportDialogShowing: "onExportDialogShowing", onExportDialogShown: "onExportDialogShown" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardExportComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-dashboard-export', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { allowExportDashboard: [{
                type: Input
            }], allowExportDashboardItems: [{
                type: Input
            }], onExportDialogHidden: [{
                type: Input
            }], onExportDialogShowing: [{
                type: Input
            }], onExportDialogShown: [{
                type: Input
            }] } });
class DxoDashboardControlDashboardExportModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardExportModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardExportModule, declarations: [DxoDashboardControlDashboardExportComponent], exports: [DxoDashboardControlDashboardExportComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardExportModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardExportModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlDashboardExportComponent
                    ],
                    exports: [
                        DxoDashboardControlDashboardExportComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlDashboardParameterDialogComponent extends NestedOption {
    get onDynamicLookUpValuesLoaded() {
        return this._getOption('onDynamicLookUpValuesLoaded');
    }
    set onDynamicLookUpValuesLoaded(value) {
        this._setOption('onDynamicLookUpValuesLoaded', value);
    }
    get onHidden() {
        return this._getOption('onHidden');
    }
    set onHidden(value) {
        this._setOption('onHidden', value);
    }
    get onShowing() {
        return this._getOption('onShowing');
    }
    set onShowing(value) {
        this._setOption('onShowing', value);
    }
    get onShown() {
        return this._getOption('onShown');
    }
    set onShown(value) {
        this._setOption('onShown', value);
    }
    get _optionPath() {
        return 'dashboardParameterDialog';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardParameterDialogComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlDashboardParameterDialogComponent, selector: "dxo-dashboard-control-dashboard-parameter-dialog", inputs: { onDynamicLookUpValuesLoaded: "onDynamicLookUpValuesLoaded", onHidden: "onHidden", onShowing: "onShowing", onShown: "onShown" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardParameterDialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-dashboard-parameter-dialog', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { onDynamicLookUpValuesLoaded: [{
                type: Input
            }], onHidden: [{
                type: Input
            }], onShowing: [{
                type: Input
            }], onShown: [{
                type: Input
            }] } });
class DxoDashboardControlDashboardParameterDialogModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardParameterDialogModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardParameterDialogModule, declarations: [DxoDashboardControlDashboardParameterDialogComponent], exports: [DxoDashboardControlDashboardParameterDialogComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardParameterDialogModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDashboardParameterDialogModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlDashboardParameterDialogComponent
                    ],
                    exports: [
                        DxoDashboardControlDashboardParameterDialogComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlDataInspectorComponent extends NestedOption {
    get allowInspectAggregatedData() {
        return this._getOption('allowInspectAggregatedData');
    }
    set allowInspectAggregatedData(value) {
        this._setOption('allowInspectAggregatedData', value);
    }
    get allowInspectRawData() {
        return this._getOption('allowInspectRawData');
    }
    set allowInspectRawData(value) {
        this._setOption('allowInspectRawData', value);
    }
    get onDialogHidden() {
        return this._getOption('onDialogHidden');
    }
    set onDialogHidden(value) {
        this._setOption('onDialogHidden', value);
    }
    get onDialogShowing() {
        return this._getOption('onDialogShowing');
    }
    set onDialogShowing(value) {
        this._setOption('onDialogShowing', value);
    }
    get onDialogShown() {
        return this._getOption('onDialogShown');
    }
    set onDialogShown(value) {
        this._setOption('onDialogShown', value);
    }
    get onGridContentReady() {
        return this._getOption('onGridContentReady');
    }
    set onGridContentReady(value) {
        this._setOption('onGridContentReady', value);
    }
    get onGridInitialized() {
        return this._getOption('onGridInitialized');
    }
    set onGridInitialized(value) {
        this._setOption('onGridInitialized', value);
    }
    get _optionPath() {
        return 'dataInspector';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataInspectorComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlDataInspectorComponent, selector: "dxo-dashboard-control-data-inspector", inputs: { allowInspectAggregatedData: "allowInspectAggregatedData", allowInspectRawData: "allowInspectRawData", onDialogHidden: "onDialogHidden", onDialogShowing: "onDialogShowing", onDialogShown: "onDialogShown", onGridContentReady: "onGridContentReady", onGridInitialized: "onGridInitialized" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataInspectorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-data-inspector', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { allowInspectAggregatedData: [{
                type: Input
            }], allowInspectRawData: [{
                type: Input
            }], onDialogHidden: [{
                type: Input
            }], onDialogShowing: [{
                type: Input
            }], onDialogShown: [{
                type: Input
            }], onGridContentReady: [{
                type: Input
            }], onGridInitialized: [{
                type: Input
            }] } });
class DxoDashboardControlDataInspectorModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataInspectorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataInspectorModule, declarations: [DxoDashboardControlDataInspectorComponent], exports: [DxoDashboardControlDataInspectorComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataInspectorModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataInspectorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlDataInspectorComponent
                    ],
                    exports: [
                        DxoDashboardControlDataInspectorComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlDataRequestOptionsComponent extends NestedOption {
    get itemDataLoadingMode() {
        return this._getOption('itemDataLoadingMode');
    }
    set itemDataLoadingMode(value) {
        this._setOption('itemDataLoadingMode', value);
    }
    get itemDataRequestMode() {
        return this._getOption('itemDataRequestMode');
    }
    set itemDataRequestMode(value) {
        this._setOption('itemDataRequestMode', value);
    }
    get _optionPath() {
        return 'dataRequestOptions';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataRequestOptionsComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlDataRequestOptionsComponent, selector: "dxo-dashboard-control-data-request-options", inputs: { itemDataLoadingMode: "itemDataLoadingMode", itemDataRequestMode: "itemDataRequestMode" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataRequestOptionsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-data-request-options', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { itemDataLoadingMode: [{
                type: Input
            }], itemDataRequestMode: [{
                type: Input
            }] } });
class DxoDashboardControlDataRequestOptionsModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataRequestOptionsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataRequestOptionsModule, declarations: [DxoDashboardControlDataRequestOptionsComponent], exports: [DxoDashboardControlDataRequestOptionsComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataRequestOptionsModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataRequestOptionsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlDataRequestOptionsComponent
                    ],
                    exports: [
                        DxoDashboardControlDataRequestOptionsComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlDataSourceWizardComponent extends NestedOption {
    get allowCreateNewJsonConnection() {
        return this._getOption('allowCreateNewJsonConnection');
    }
    set allowCreateNewJsonConnection(value) {
        this._setOption('allowCreateNewJsonConnection', value);
    }
    get enableCustomSql() {
        return this._getOption('enableCustomSql');
    }
    set enableCustomSql(value) {
        this._setOption('enableCustomSql', value);
    }
    get onCustomizeDataSourceWizard() {
        return this._getOption('onCustomizeDataSourceWizard');
    }
    set onCustomizeDataSourceWizard(value) {
        this._setOption('onCustomizeDataSourceWizard', value);
    }
    get wizardSettings() {
        return this._getOption('wizardSettings');
    }
    set wizardSettings(value) {
        this._setOption('wizardSettings', value);
    }
    get _optionPath() {
        return 'dataSourceWizard';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataSourceWizardComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlDataSourceWizardComponent, selector: "dxo-dashboard-control-data-source-wizard", inputs: { allowCreateNewJsonConnection: "allowCreateNewJsonConnection", enableCustomSql: "enableCustomSql", onCustomizeDataSourceWizard: "onCustomizeDataSourceWizard", wizardSettings: "wizardSettings" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataSourceWizardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-data-source-wizard', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { allowCreateNewJsonConnection: [{
                type: Input
            }], enableCustomSql: [{
                type: Input
            }], onCustomizeDataSourceWizard: [{
                type: Input
            }], wizardSettings: [{
                type: Input
            }] } });
class DxoDashboardControlDataSourceWizardModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataSourceWizardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataSourceWizardModule, declarations: [DxoDashboardControlDataSourceWizardComponent], exports: [DxoDashboardControlDataSourceWizardComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataSourceWizardModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDataSourceWizardModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlDataSourceWizardComponent
                    ],
                    exports: [
                        DxoDashboardControlDataSourceWizardComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlDesignerToolbarComponent extends NestedOption {
    get onPreparing() {
        return this._getOption('onPreparing');
    }
    set onPreparing(value) {
        this._setOption('onPreparing', value);
    }
    get _optionPath() {
        return 'designerToolbar';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDesignerToolbarComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlDesignerToolbarComponent, selector: "dxo-dashboard-control-designer-toolbar", inputs: { onPreparing: "onPreparing" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDesignerToolbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-designer-toolbar', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { onPreparing: [{
                type: Input
            }] } });
class DxoDashboardControlDesignerToolbarModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDesignerToolbarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDesignerToolbarModule, declarations: [DxoDashboardControlDesignerToolbarComponent], exports: [DxoDashboardControlDesignerToolbarComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDesignerToolbarModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlDesignerToolbarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlDesignerToolbarComponent
                    ],
                    exports: [
                        DxoDashboardControlDesignerToolbarComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlExtensionsComponent extends NestedOption {
    get chartIndicators() {
        return this._getOption('chartIndicators');
    }
    set chartIndicators(value) {
        this._setOption('chartIndicators', value);
    }
    get dashboardExport() {
        return this._getOption('dashboardExport');
    }
    set dashboardExport(value) {
        this._setOption('dashboardExport', value);
    }
    get dashboardParameterDialog() {
        return this._getOption('dashboardParameterDialog');
    }
    set dashboardParameterDialog(value) {
        this._setOption('dashboardParameterDialog', value);
    }
    get dataInspector() {
        return this._getOption('dataInspector');
    }
    set dataInspector(value) {
        this._setOption('dataInspector', value);
    }
    get dataSourceWizard() {
        return this._getOption('dataSourceWizard');
    }
    set dataSourceWizard(value) {
        this._setOption('dataSourceWizard', value);
    }
    get designerToolbar() {
        return this._getOption('designerToolbar');
    }
    set designerToolbar(value) {
        this._setOption('designerToolbar', value);
    }
    get itemBindingPanel() {
        return this._getOption('itemBindingPanel');
    }
    set itemBindingPanel(value) {
        this._setOption('itemBindingPanel', value);
    }
    get itemOptionsPanel() {
        return this._getOption('itemOptionsPanel');
    }
    set itemOptionsPanel(value) {
        this._setOption('itemOptionsPanel', value);
    }
    get mobileLayout() {
        return this._getOption('mobileLayout');
    }
    set mobileLayout(value) {
        this._setOption('mobileLayout', value);
    }
    get textBoxItemEditor() {
        return this._getOption('textBoxItemEditor');
    }
    set textBoxItemEditor(value) {
        this._setOption('textBoxItemEditor', value);
    }
    get viewerApi() {
        return this._getOption('viewerApi');
    }
    set viewerApi(value) {
        this._setOption('viewerApi', value);
    }
    get _optionPath() {
        return 'extensions';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlExtensionsComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlExtensionsComponent, selector: "dxo-dashboard-control-extensions", inputs: { chartIndicators: "chartIndicators", dashboardExport: "dashboardExport", dashboardParameterDialog: "dashboardParameterDialog", dataInspector: "dataInspector", dataSourceWizard: "dataSourceWizard", designerToolbar: "designerToolbar", itemBindingPanel: "itemBindingPanel", itemOptionsPanel: "itemOptionsPanel", mobileLayout: "mobileLayout", textBoxItemEditor: "textBoxItemEditor", viewerApi: "viewerApi" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlExtensionsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-extensions', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { chartIndicators: [{
                type: Input
            }], dashboardExport: [{
                type: Input
            }], dashboardParameterDialog: [{
                type: Input
            }], dataInspector: [{
                type: Input
            }], dataSourceWizard: [{
                type: Input
            }], designerToolbar: [{
                type: Input
            }], itemBindingPanel: [{
                type: Input
            }], itemOptionsPanel: [{
                type: Input
            }], mobileLayout: [{
                type: Input
            }], textBoxItemEditor: [{
                type: Input
            }], viewerApi: [{
                type: Input
            }] } });
class DxoDashboardControlExtensionsModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlExtensionsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlExtensionsModule, declarations: [DxoDashboardControlExtensionsComponent], exports: [DxoDashboardControlExtensionsComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlExtensionsModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlExtensionsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlExtensionsComponent
                    ],
                    exports: [
                        DxoDashboardControlExtensionsComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlFetchRemoteServiceComponent extends NestedOption {
    get beforeSend() {
        return this._getOption('beforeSend');
    }
    set beforeSend(value) {
        this._setOption('beforeSend', value);
    }
    get headers() {
        return this._getOption('headers');
    }
    set headers(value) {
        this._setOption('headers', value);
    }
    get _optionPath() {
        return 'fetchRemoteService';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlFetchRemoteServiceComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlFetchRemoteServiceComponent, selector: "dxo-dashboard-control-fetch-remote-service", inputs: { beforeSend: "beforeSend", headers: "headers" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlFetchRemoteServiceComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-fetch-remote-service', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { beforeSend: [{
                type: Input
            }], headers: [{
                type: Input
            }] } });
class DxoDashboardControlFetchRemoteServiceModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlFetchRemoteServiceModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlFetchRemoteServiceModule, declarations: [DxoDashboardControlFetchRemoteServiceComponent], exports: [DxoDashboardControlFetchRemoteServiceComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlFetchRemoteServiceModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlFetchRemoteServiceModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlFetchRemoteServiceComponent
                    ],
                    exports: [
                        DxoDashboardControlFetchRemoteServiceComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlItemBindingPanelComponent extends NestedOption {
    get onCustomizeDataItemContainerSections() {
        return this._getOption('onCustomizeDataItemContainerSections');
    }
    set onCustomizeDataItemContainerSections(value) {
        this._setOption('onCustomizeDataItemContainerSections', value);
    }
    get _optionPath() {
        return 'itemBindingPanel';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemBindingPanelComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlItemBindingPanelComponent, selector: "dxo-dashboard-control-item-binding-panel", inputs: { onCustomizeDataItemContainerSections: "onCustomizeDataItemContainerSections" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemBindingPanelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-item-binding-panel', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { onCustomizeDataItemContainerSections: [{
                type: Input
            }] } });
class DxoDashboardControlItemBindingPanelModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemBindingPanelModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemBindingPanelModule, declarations: [DxoDashboardControlItemBindingPanelComponent], exports: [DxoDashboardControlItemBindingPanelComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemBindingPanelModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemBindingPanelModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlItemBindingPanelComponent
                    ],
                    exports: [
                        DxoDashboardControlItemBindingPanelComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlItemOptionsPanelComponent extends NestedOption {
    get onCustomizeSections() {
        return this._getOption('onCustomizeSections');
    }
    set onCustomizeSections(value) {
        this._setOption('onCustomizeSections', value);
    }
    get _optionPath() {
        return 'itemOptionsPanel';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemOptionsPanelComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlItemOptionsPanelComponent, selector: "dxo-dashboard-control-item-options-panel", inputs: { onCustomizeSections: "onCustomizeSections" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemOptionsPanelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-item-options-panel', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { onCustomizeSections: [{
                type: Input
            }] } });
class DxoDashboardControlItemOptionsPanelModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemOptionsPanelModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemOptionsPanelModule, declarations: [DxoDashboardControlItemOptionsPanelComponent], exports: [DxoDashboardControlItemOptionsPanelComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemOptionsPanelModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlItemOptionsPanelModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlItemOptionsPanelComponent
                    ],
                    exports: [
                        DxoDashboardControlItemOptionsPanelComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlMobileLayoutComponent extends NestedOption {
    get mobileLayoutEnabled() {
        return this._getOption('mobileLayoutEnabled');
    }
    set mobileLayoutEnabled(value) {
        this._setOption('mobileLayoutEnabled', value);
    }
    get _optionPath() {
        return 'mobileLayout';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlMobileLayoutComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlMobileLayoutComponent, selector: "dxo-dashboard-control-mobile-layout", inputs: { mobileLayoutEnabled: "mobileLayoutEnabled" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlMobileLayoutComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-mobile-layout', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { mobileLayoutEnabled: [{
                type: Input
            }] } });
class DxoDashboardControlMobileLayoutModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlMobileLayoutModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlMobileLayoutModule, declarations: [DxoDashboardControlMobileLayoutComponent], exports: [DxoDashboardControlMobileLayoutComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlMobileLayoutModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlMobileLayoutModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlMobileLayoutComponent
                    ],
                    exports: [
                        DxoDashboardControlMobileLayoutComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlTextBoxItemEditorComponent extends NestedOption {
    get onRichEditCreated() {
        return this._getOption('onRichEditCreated');
    }
    set onRichEditCreated(value) {
        this._setOption('onRichEditCreated', value);
    }
    get onRichEditOptionsPrepared() {
        return this._getOption('onRichEditOptionsPrepared');
    }
    set onRichEditOptionsPrepared(value) {
        this._setOption('onRichEditOptionsPrepared', value);
    }
    get _optionPath() {
        return 'textBoxItemEditor';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlTextBoxItemEditorComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlTextBoxItemEditorComponent, selector: "dxo-dashboard-control-text-box-item-editor", inputs: { onRichEditCreated: "onRichEditCreated", onRichEditOptionsPrepared: "onRichEditOptionsPrepared" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlTextBoxItemEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-text-box-item-editor', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { onRichEditCreated: [{
                type: Input
            }], onRichEditOptionsPrepared: [{
                type: Input
            }] } });
class DxoDashboardControlTextBoxItemEditorModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlTextBoxItemEditorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlTextBoxItemEditorModule, declarations: [DxoDashboardControlTextBoxItemEditorComponent], exports: [DxoDashboardControlTextBoxItemEditorComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlTextBoxItemEditorModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlTextBoxItemEditorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlTextBoxItemEditorComponent
                    ],
                    exports: [
                        DxoDashboardControlTextBoxItemEditorComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlViewerApiComponent extends NestedOption {
    get onDashboardTitleToolbarUpdated() {
        return this._getOption('onDashboardTitleToolbarUpdated');
    }
    set onDashboardTitleToolbarUpdated(value) {
        this._setOption('onDashboardTitleToolbarUpdated', value);
    }
    get onItemActionAvailabilityChanged() {
        return this._getOption('onItemActionAvailabilityChanged');
    }
    set onItemActionAvailabilityChanged(value) {
        this._setOption('onItemActionAvailabilityChanged', value);
    }
    get onItemCaptionToolbarUpdated() {
        return this._getOption('onItemCaptionToolbarUpdated');
    }
    set onItemCaptionToolbarUpdated(value) {
        this._setOption('onItemCaptionToolbarUpdated', value);
    }
    get onItemClick() {
        return this._getOption('onItemClick');
    }
    set onItemClick(value) {
        this._setOption('onItemClick', value);
    }
    get onItemDrillDownStateChanged() {
        return this._getOption('onItemDrillDownStateChanged');
    }
    set onItemDrillDownStateChanged(value) {
        this._setOption('onItemDrillDownStateChanged', value);
    }
    get onItemElementCustomColor() {
        return this._getOption('onItemElementCustomColor');
    }
    set onItemElementCustomColor(value) {
        this._setOption('onItemElementCustomColor', value);
    }
    get onItemMasterFilterStateChanged() {
        return this._getOption('onItemMasterFilterStateChanged');
    }
    set onItemMasterFilterStateChanged(value) {
        this._setOption('onItemMasterFilterStateChanged', value);
    }
    get onItemSelectionChanged() {
        return this._getOption('onItemSelectionChanged');
    }
    set onItemSelectionChanged(value) {
        this._setOption('onItemSelectionChanged', value);
    }
    get onItemVisualInteractivity() {
        return this._getOption('onItemVisualInteractivity');
    }
    set onItemVisualInteractivity(value) {
        this._setOption('onItemVisualInteractivity', value);
    }
    get onItemWidgetCreated() {
        return this._getOption('onItemWidgetCreated');
    }
    set onItemWidgetCreated(value) {
        this._setOption('onItemWidgetCreated', value);
    }
    get onItemWidgetOptionsPrepared() {
        return this._getOption('onItemWidgetOptionsPrepared');
    }
    set onItemWidgetOptionsPrepared(value) {
        this._setOption('onItemWidgetOptionsPrepared', value);
    }
    get onItemWidgetUpdated() {
        return this._getOption('onItemWidgetUpdated');
    }
    set onItemWidgetUpdated(value) {
        this._setOption('onItemWidgetUpdated', value);
    }
    get onItemWidgetUpdating() {
        return this._getOption('onItemWidgetUpdating');
    }
    set onItemWidgetUpdating(value) {
        this._setOption('onItemWidgetUpdating', value);
    }
    get onSelectedTabPageChanged() {
        return this._getOption('onSelectedTabPageChanged');
    }
    set onSelectedTabPageChanged(value) {
        this._setOption('onSelectedTabPageChanged', value);
    }
    get _optionPath() {
        return 'viewerApi';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlViewerApiComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlViewerApiComponent, selector: "dxo-dashboard-control-viewer-api", inputs: { onDashboardTitleToolbarUpdated: "onDashboardTitleToolbarUpdated", onItemActionAvailabilityChanged: "onItemActionAvailabilityChanged", onItemCaptionToolbarUpdated: "onItemCaptionToolbarUpdated", onItemClick: "onItemClick", onItemDrillDownStateChanged: "onItemDrillDownStateChanged", onItemElementCustomColor: "onItemElementCustomColor", onItemMasterFilterStateChanged: "onItemMasterFilterStateChanged", onItemSelectionChanged: "onItemSelectionChanged", onItemVisualInteractivity: "onItemVisualInteractivity", onItemWidgetCreated: "onItemWidgetCreated", onItemWidgetOptionsPrepared: "onItemWidgetOptionsPrepared", onItemWidgetUpdated: "onItemWidgetUpdated", onItemWidgetUpdating: "onItemWidgetUpdating", onSelectedTabPageChanged: "onSelectedTabPageChanged" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlViewerApiComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-viewer-api', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { onDashboardTitleToolbarUpdated: [{
                type: Input
            }], onItemActionAvailabilityChanged: [{
                type: Input
            }], onItemCaptionToolbarUpdated: [{
                type: Input
            }], onItemClick: [{
                type: Input
            }], onItemDrillDownStateChanged: [{
                type: Input
            }], onItemElementCustomColor: [{
                type: Input
            }], onItemMasterFilterStateChanged: [{
                type: Input
            }], onItemSelectionChanged: [{
                type: Input
            }], onItemVisualInteractivity: [{
                type: Input
            }], onItemWidgetCreated: [{
                type: Input
            }], onItemWidgetOptionsPrepared: [{
                type: Input
            }], onItemWidgetUpdated: [{
                type: Input
            }], onItemWidgetUpdating: [{
                type: Input
            }], onSelectedTabPageChanged: [{
                type: Input
            }] } });
class DxoDashboardControlViewerApiModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlViewerApiModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlViewerApiModule, declarations: [DxoDashboardControlViewerApiComponent], exports: [DxoDashboardControlViewerApiComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlViewerApiModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlViewerApiModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlViewerApiComponent
                    ],
                    exports: [
                        DxoDashboardControlViewerApiComponent
                    ],
                }]
        }] });

/* tslint:disable:max-line-length */
class DxoDashboardControlWizardSettingsComponent extends NestedOption {
    get enableFederationDataSource() {
        return this._getOption('enableFederationDataSource');
    }
    set enableFederationDataSource(value) {
        this._setOption('enableFederationDataSource', value);
    }
    get enableJsonDataSource() {
        return this._getOption('enableJsonDataSource');
    }
    set enableJsonDataSource(value) {
        this._setOption('enableJsonDataSource', value);
    }
    get enableOlapDataSource() {
        return this._getOption('enableOlapDataSource');
    }
    set enableOlapDataSource(value) {
        this._setOption('enableOlapDataSource', value);
    }
    get enableSqlDataSource() {
        return this._getOption('enableSqlDataSource');
    }
    set enableSqlDataSource(value) {
        this._setOption('enableSqlDataSource', value);
    }
    get _optionPath() {
        return 'wizardSettings';
    }
    constructor(parentOptionHost, optionHost) {
        super();
        parentOptionHost.setNestedOption(this);
        optionHost.setHost(this, this._fullOptionPath.bind(this));
    }
    ngOnInit() {
        this._addRecreatedComponent();
    }
    ngOnDestroy() {
        this._addRemovedOption(this._getOptionPath());
    }
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlWizardSettingsComponent, deps: [{ token: i1.NestedOptionHost, host: true, skipSelf: true }, { token: i1.NestedOptionHost, host: true }], target: i0.ɵɵFactoryTarget.Component });
    /** @nocollapse */ static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: DxoDashboardControlWizardSettingsComponent, selector: "dxo-dashboard-control-wizard-settings", inputs: { enableFederationDataSource: "enableFederationDataSource", enableJsonDataSource: "enableJsonDataSource", enableOlapDataSource: "enableOlapDataSource", enableSqlDataSource: "enableSqlDataSource" }, providers: [NestedOptionHost], usesInheritance: true, ngImport: i0, template: '', isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlWizardSettingsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dxo-dashboard-control-wizard-settings', template: '', providers: [NestedOptionHost] }]
        }], ctorParameters: () => [{ type: i1.NestedOptionHost, decorators: [{
                    type: SkipSelf
                }, {
                    type: Host
                }] }, { type: i1.NestedOptionHost, decorators: [{
                    type: Host
                }] }], propDecorators: { enableFederationDataSource: [{
                type: Input
            }], enableJsonDataSource: [{
                type: Input
            }], enableOlapDataSource: [{
                type: Input
            }], enableSqlDataSource: [{
                type: Input
            }] } });
class DxoDashboardControlWizardSettingsModule {
    /** @nocollapse */ static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlWizardSettingsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlWizardSettingsModule, declarations: [DxoDashboardControlWizardSettingsComponent], exports: [DxoDashboardControlWizardSettingsComponent] });
    /** @nocollapse */ static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlWizardSettingsModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: DxoDashboardControlWizardSettingsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DxoDashboardControlWizardSettingsComponent
                    ],
                    exports: [
                        DxoDashboardControlWizardSettingsComponent
                    ],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { DxoDashboardControlAjaxRemoteServiceComponent, DxoDashboardControlAjaxRemoteServiceModule, DxoDashboardControlChartIndicatorsComponent, DxoDashboardControlChartIndicatorsModule, DxoDashboardControlDashboardExportComponent, DxoDashboardControlDashboardExportModule, DxoDashboardControlDashboardParameterDialogComponent, DxoDashboardControlDashboardParameterDialogModule, DxoDashboardControlDataInspectorComponent, DxoDashboardControlDataInspectorModule, DxoDashboardControlDataRequestOptionsComponent, DxoDashboardControlDataRequestOptionsModule, DxoDashboardControlDataSourceWizardComponent, DxoDashboardControlDataSourceWizardModule, DxoDashboardControlDesignerToolbarComponent, DxoDashboardControlDesignerToolbarModule, DxoDashboardControlExtensionsComponent, DxoDashboardControlExtensionsModule, DxoDashboardControlFetchRemoteServiceComponent, DxoDashboardControlFetchRemoteServiceModule, DxoDashboardControlItemBindingPanelComponent, DxoDashboardControlItemBindingPanelModule, DxoDashboardControlItemOptionsPanelComponent, DxoDashboardControlItemOptionsPanelModule, DxoDashboardControlMobileLayoutComponent, DxoDashboardControlMobileLayoutModule, DxoDashboardControlTextBoxItemEditorComponent, DxoDashboardControlTextBoxItemEditorModule, DxoDashboardControlViewerApiComponent, DxoDashboardControlViewerApiModule, DxoDashboardControlWizardSettingsComponent, DxoDashboardControlWizardSettingsModule };
//# sourceMappingURL=devexpress-dashboard-angular-ui-dashboard-control-nested.mjs.map
