import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoAjaxRemoteServiceComponent extends NestedOption implements OnDestroy, OnInit {
    get beforeSend(): Function;
    set beforeSend(value: Function);
    get complete(): Function;
    set complete(value: Function);
    get headers(): any;
    set headers(value: any);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoAjaxRemoteServiceComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoAjaxRemoteServiceComponent, "dxo-ajax-remote-service", never, { "beforeSend": { "alias": "beforeSend"; "required": false; }; "complete": { "alias": "complete"; "required": false; }; "headers": { "alias": "headers"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoAjaxRemoteServiceModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoAjaxRemoteServiceModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoAjaxRemoteServiceModule, [typeof DxoAjaxRemoteServiceComponent], never, [typeof DxoAjaxRemoteServiceComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoAjaxRemoteServiceModule>;
}
