import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDashboardParameterDialogComponent extends NestedOption implements OnDestroy, OnInit {
    get onDynamicLookUpValuesLoaded(): Function;
    set onDynamicLookUpValuesLoaded(value: Function);
    get onHidden(): Function;
    set onHidden(value: Function);
    get onShowing(): Function;
    set onShowing(value: Function);
    get onShown(): Function;
    set onShown(value: Function);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDashboardParameterDialogComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDashboardParameterDialogComponent, "dxo-dashboard-parameter-dialog", never, { "onDynamicLookUpValuesLoaded": { "alias": "onDynamicLookUpValuesLoaded"; "required": false; }; "onHidden": { "alias": "onHidden"; "required": false; }; "onShowing": { "alias": "onShowing"; "required": false; }; "onShown": { "alias": "onShown"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDashboardParameterDialogModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDashboardParameterDialogModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDashboardParameterDialogModule, [typeof DxoDashboardParameterDialogComponent], never, [typeof DxoDashboardParameterDialogComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDashboardParameterDialogModule>;
}
